* Make a complete window definition	v0.00   1987  J.R.Oakley  QJUMP
*
	section prog
*
	include 'dev8_keys_wwork'
	include 'dev1_asm_qptr_keys'
	include 'dev8_keys_err'
	include 'dev8_mac_assert'
*
	xref	ut_lfla1
	xref	ut_retfp
*
	xref	bem_achp
	xref	bem_rchp
	xref	bem_ciar
	xref	bem_swat
	xref	bem_gwat
	xref	bem_sri6
	xref	bem_siat
	xref	bem_giat
	xref	bem_cpya
*
	xdef	bem_cgpt
*
	xdef	be_mkwdf
*
be_mkwdf
	moveq	#ww_lists,d1
	jsr	bem_achp(pc)		; allocate space for header
	bne	bem_exnr		; no room
	move.l	a0,a4			; point to working definition
*
	jsr	bem_swat(pc)		; set up for window definition
	bne.s	bem_exit		; bomb
	lea	ww_xsize(a4),a2 	; where to put...
	jsr	bem_gwat(pc)		; ...the window attributes
*
	addq.l	#8,a3			; next parameter
	jsr	bem_swat(pc)		; set up for window attributes
	bne.s	bem_exit		; boing
	lea	ww_wattr(a4),a2 	; point to and...
	jsr	bem_gwat(pc)		; ...get the window attributes
*
	addq.l	#8,a3			; next parameter
	bsr.s	bem_cgpt		; is a pointer
	beq.s	bem_fltb		; but it's zero
	move.l	a1,ww_psprt(a4) 	; to the pointer sprite
bem_fltb
	addq.l	#8,a3
	bsr.s	bem_cgpt
	beq.s	bem_fitb		; no loose item table
	addq.w	#mol_numo,a1		; skip heap header bits
	lea	ww_nlitm(a4),a0 	; where number goes
	move.w	(a1)+,(a0)+		; get number
	lea	ww_lattr(a4),a2 	; where the attributes go
	jsr	bem_cpya(pc)		; copy them
	add.w	#wwa.elen,a1		; and skip past
*
	assert	ww_plitm,ww_nlitm+2
	move.l	a1,(a0) 		; fill in pointer to loose item table
bem_fitb
	addq.l	#8,a3
	bsr.s	bem_cgpt		; any information?
	beq.s	bem_fatb		; not the proverbial sausage
	lea	ww_ninfo(a4),a0
	assert	ww_ninfo,ww_ninob-2,ww_pinfo-4
	move.l	(a1)+,(a0)+		; numbers of windows and objects
	move.l	a1,(a0) 		; and where they are
bem_fatb
	addq.l	#8,a3
	bsr.s	bem_cgpt
	beq.s	bem_rtad		; no application windows
	lea	ww_nappl(a4),a0 	; where number goes
	move.w	(a1)+,(a0)+		; get number
	assert	ww_pappl,ww_nappl+2
	move.l	a1,(a0) 		; fill in pointer to list
	move.l	a1,ww_splst(a4) 	; sub-window list pointer is the same
*
bem_rtad
	move.l	a4,d1			; set D1 to base of table
	jsr	ut_lfla1(pc)		; and push D1 (floated) onto RI stack
	jmp	ut_retfp(pc)		; and return with 
*
bem_exit
	move.l	a4,a0
	move.l	d0,d3
	jsr	bem_rchp(pc)		; return heap
	move.l	d3,d0
bem_exnr
	rts
bem_exbp
	moveq	#err.ipar,d0
	bra.s	bem_exit
*
*	Get a pointer: no error return, if an error occurs then the 
*	pointer is assumed to be zero
*
*	Registers:
*	      Entry			Exit
*	D0/CCR				pointer
*	A1				pointer
*	A3	NT entry			preserved
*
gptreg	reg	d1-d4/d6/a0/a2/a5
bem_cgpt
	sub.l	a1,a1		; assume there's no parameter
	cmp.l	a3,a5		; is there a parameter at all?
	ble.s	bem_xgpt		; no
	movem.l gptreg,-(sp)
	lea	8(a3),a5		; just get one parameter
	move.w	ca.gtlin,a2		; a long integer
	jsr	(a2)
	bne.s	bem_npar		; error, assume no pointer
	addq.l	#4,a1
	move.l	a1,bv_rip(a6)	; success, wind back RI stack
	move.l	-4(a6,a1.l),a1	; and get the answer
	bra.s	bem_xpar
bem_npar
	sub.l	a1,a1
bem_xpar
	movem.l (sp)+,gptreg
bem_xgpt
	move.l	a1,d0		; flag sign of pointer
	rts
*
	end
